

namespace ListViewSort
{
	using System;
	using System.Drawing;
	using System.Collections;
	using System.ComponentModel;
	using System.Windows.Forms;
	using System.Data;

	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ListView listView1;
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// Create a new ListView control.
			//	ListView listView1 = new ListView();
			listView1.Bounds = new Rectangle(new Point(10,10), new Size(300,200));

			// Set the view to show details.
			listView1.View = View.Details;
			// Allow the user to edit item text.
			listView1.LabelEdit = true;
			// Allow the user to rearrange columns.
			listView1.AllowColumnReorder = true;
			// Display check boxes.
			listView1.CheckBoxes = true;
			// Select the item and subitems when selection is made.
			listView1.FullRowSelect = true;
			// Display grid lines.
			listView1.GridLines = true;
			// Sort the items in the list in ascending order.
			listView1.Sorting = SortOrder.Ascending;
                     
			// Create three items and three sets of subitems for each item.
			ListViewItem item1 = new ListViewItem("item1",0);
			// Place a check mark next to the item.
			item1.Checked = true;
			item1.SubItems.Add("1");
			item1.SubItems.Add("44");
			item1.SubItems.Add("3");
			ListViewItem item2 = new ListViewItem("item2",1);
			item2.SubItems.Add("22");
			item2.SubItems.Add("5");
			item2.SubItems.Add("3");
			ListViewItem item3 = new ListViewItem("item3",0);
			// Place a check mark next to the item.
			item3.Checked = true;
			item3.SubItems.Add("66");
			item3.SubItems.Add("23");
			item3.SubItems.Add("43");
			ListViewItem item4 = new ListViewItem("item4",0);
			// Place a check mark next to the item.
			item4.Checked = true;
			item4.SubItems.Add("11");
			item4.SubItems.Add("8");
			item4.SubItems.Add("1");
			ListViewItem item5 = new ListViewItem("item5",2);
			// Place a check mark next to the item.
			item5.Checked = true;
			item5.SubItems.Add("5");
			item5.SubItems.Add("44");
			item5.SubItems.Add("13");
			ListViewItem item6 = new ListViewItem("item6",0);
			// Place a check mark next to the item.
			item6.Checked = true;
			item6.SubItems.Add("0");
			item6.SubItems.Add("-1");
			item6.SubItems.Add("48");

			// Create columns for the items and subitems.
			listView1.Columns.Add("Item Column", -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Column 2", -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Column 3", -2, HorizontalAlignment.Left);
			listView1.Columns.Add("Column 4", -2, HorizontalAlignment.Center);

			//Add the items to the ListView.
			listView1.Items.AddRange(new ListViewItem[]{item1,item2,item3, item4, item5, item6});

			// Create two ImageList objects.
			ImageList imageListSmall = new ImageList();
			ImageList imageListLarge = new ImageList();

			// Initialize the ImageList objects with bitmaps.
			imageListSmall.Images.Add(SystemIcons.Asterisk.ToBitmap());
			imageListSmall.Images.Add(SystemIcons.Application.ToBitmap());
			imageListLarge.Images.Add(SystemIcons.Exclamation.ToBitmap());
			imageListLarge.Images.Add(SystemIcons.Hand.ToBitmap());

			//Assign the ImageList objects to the ListView.
			listView1.LargeImageList = imageListLarge;
			listView1.SmallImageList = imageListSmall;

			
			this.listView1.DragDrop += new DragEventHandler(listView1_DragDrop);
			this.listView1.DragEnter += new DragEventHandler(listView1_DragEnter);
			this.listView1.AllowDrop = true;
	
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.listView1 = new System.Windows.Forms.ListView();
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// listView1
			// 
			this.listView1.Location = new System.Drawing.Point(8, 24);
			this.listView1.Name = "listView1";
			this.listView1.Size = new System.Drawing.Size(312, 240);
			this.listView1.TabIndex = 0;
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(376, 16);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(232, 240);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 1;
			this.gridDataBoundGrid1.Text = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 277);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.Controls.Add(this.listView1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		public static void Main() 
		{
			Application.Run(new Form1());
		}

		

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");

			int nCols = 4;
			int nRows = 10;

			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
					dr[j] = string.Format("row{0} col{1}", i, j);
				dt.Rows.Add(dr);
			}

			this.gridDataBoundGrid1.DataSource = dt;
		}

		private void listView1_DragDrop(object sender, DragEventArgs e)
		{
			if(e.Data.GetDataPresent(DataFormats.Text))
			{
				string s = (string) e.Data.GetData(DataFormats.Text);
				string[] lines = s.Split(new char[]{'\r'});

				foreach(string line in lines)
				{
					//the Trim gets rid of a \n that is left over from the \r\n newline delimiter
					string[] cols = line.Trim().Split(new char[]{'\t'});
					foreach(string col in cols)
					{
						Console.Write(" " + col);
					}
					Console.WriteLine();
				}

				//used as return value of source's DoDragDrop call
				e.Effect = DragDropEffects.Copy;
			}
		}

		private void listView1_DragEnter(object sender, DragEventArgs e)
		{
			if(e.Data.GetDataPresent(DataFormats.Text))
			{
				e.Effect = DragDropEffects.Copy;
			}
		}
	}

																		  
}
